Index: issm/trunk/src/c/classes/FemModel.cpp
===================================================================
--- issm/trunk/src/c/classes/FemModel.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/FemModel.cpp	(revision 18301)
@@ -43,6 +43,5 @@
 
 /*Object constructors and destructor*/
-/*FUNCTION FemModel::FemModel(int argc,char** argv,ISSM_MPI_Comm incomm){{{*/
-FemModel::FemModel(int argc,char** argv,ISSM_MPI_Comm incomm){
+FemModel::FemModel(int argc,char** argv,ISSM_MPI_Comm incomm){/*{{{*/
 
 	/*configuration: */
@@ -94,6 +93,5 @@
 }
 /*}}}*/
-/*FUNCTION FemModel::FemModel(char* rootpath, char* inputfilename, char* outputfilename, char* toolkitsfilename, char* lockfilename, const int in_solution_type,const int* analyses,const int nummodels){{{*/
-FemModel::FemModel(char* rootpath, char* inputfilename, char* outputfilename, char* toolkitsfilename, char* lockfilename, const int in_solution_type,const int* analyses,const int nummodels){
+FemModel::FemModel(char* rootpath, char* inputfilename, char* outputfilename, char* toolkitsfilename, char* lockfilename, const int in_solution_type,const int* analyses,const int nummodels){/*{{{*/
 
 	/*Call InitFromFiles. This constructor is just a wrapper: */
@@ -102,6 +100,5 @@
 }
 /*}}}*/
-/*FUNCTION FemModel::~FemModel{{{*/
-FemModel::~FemModel(){
+FemModel::~FemModel(){/*{{{*/
 
 	/*Intermediary*/
@@ -109,18 +106,7 @@
 	char *outbinfilename = NULL;
 	char *lockfilename   = NULL;
-	bool  waitonlock     = false;
-
-	/*Close output file: */
-	this->parameters->FindParam(&output_fid,OutputFilePointerEnum); 
-	this->parameters->FindParam(&outbinfilename,OutputFileNameEnum); 
-	pfclose(output_fid,outbinfilename);
-
-	/*Write lock file if requested: */
-	this->parameters->FindParam(&waitonlock,SettingsWaitonlockEnum);
+
+	this->parameters->FindParam(&outbinfilename,OutputFileNameEnum);
 	this->parameters->FindParam(&lockfilename,LockFileNameEnum);
-	if(waitonlock){
-		_printf0_("write lock file:\n");
-		WriteLockFile(lockfilename);
-	}
 
 	/*Delete all the datasets: */
@@ -137,4 +123,113 @@
 	delete results;
 
+	/*Now delete: */
+	delete profiler;
+
+}
+/*}}}*/
+
+/*Object management*/
+void FemModel::Echo(void){/*{{{*/
+
+	_printf_("FemModel echo: \n");
+	_printf_("   number of fem models: " << nummodels << "\n");
+	_printf_("   analysis_type_list: \n");
+	for(int i=0;i<nummodels;i++)_printf_("     " << i << ": " << EnumToStringx(analysis_type_list[i]) << "\n");
+	_printf_("   current analysis_type: \n");
+	_printf_("     " << analysis_counter << ": " << EnumToStringx(analysis_type_list[analysis_counter]) << "\n");
+
+}
+/*}}}*/
+void FemModel::InitFromFiles(char* rootpath, char* inputfilename, char* outputfilename, char* toolkitsfilename, char* lockfilename, const int in_solution_type,const int* analyses,const int nummodels){/*{{{*/
+
+	/*intermediary*/
+	int         i;
+	int         analysis_type;
+	FILE       *IOMODEL = NULL;
+	FILE       *toolkitsoptionsfid = NULL;
+	FILE       *output_fid = NULL;
+	int         my_rank;
+
+	/*recover my_rank:*/
+	my_rank=IssmComm::GetRank();
+
+	/*Open input file on cpu 0: */
+	if(my_rank==0) IOMODEL = pfopen0(inputfilename ,"rb");
+
+	/*Open toolkits file: */
+	toolkitsoptionsfid=pfopen(toolkitsfilename,"r");
+
+	/*Initialize internal data: */
+	this->nummodels        = nummodels;
+	this->solution_type    = in_solution_type;
+	this->analysis_counter = nummodels-1;   //point to last analysis_type carried out.
+	this->results          = new Results(); //not initialized by CreateDataSets
+
+	/*Dynamically allocate whatever is a list of length nummodels: */
+	analysis_type_list=xNew<int>(nummodels);
+
+	/*Initialize: */
+	for(i=0;i<nummodels;i++)analysis_type_list[i]=analyses[i];
+
+	/*create datasets for all analyses*/
+	ModelProcessorx(&this->elements,&this->nodes,&this->vertices,&this->materials,&this->constraints,&this->loads,&this->parameters,IOMODEL,toolkitsoptionsfid,rootpath,this->solution_type,nummodels,analyses);
+
+	/*do the post-processing of the datasets to get an FemModel that can actually run analyses: */
+	for(i=0;i<nummodels;i++){
+
+		if(VerboseMProcessor()) _printf0_("   Processing finite element model of analysis " << EnumToStringx(analysis_type_list[i]) << ":\n");
+		analysis_type=analysis_type_list[i];
+		this->SetCurrentConfiguration(analysis_type);
+
+		if(i==0){
+			if(VerboseMProcessor()) _printf0_("      creating vertex PIDs\n");
+			VerticesDofx(vertices,parameters); //only call once, we only have one set of vertices
+		}
+
+		if(VerboseMProcessor()) _printf0_("      resolving node constraints\n");
+		SpcNodesx(nodes,constraints,parameters,analysis_type); 
+
+		if(VerboseMProcessor()) _printf0_("      creating nodal degrees of freedom\n");
+		NodesDofx(nodes,parameters,analysis_type);
+
+		if(VerboseMProcessor()) _printf0_("      configuring element and loads\n");
+		ConfigureObjectsx(elements, loads, nodes, vertices, materials,parameters);
+	}
+
+	/*Close input file and toolkits file descriptors: */
+	if(my_rank==0) pfclose(IOMODEL,inputfilename);
+	pfclose(toolkitsoptionsfid,toolkitsfilename);
+
+	/*Open output file once for all and add output file name and file descriptor to parameters*/
+	output_fid=pfopen(outputfilename,"wb");
+	this->parameters->AddObject(new StringParam(OutputFileNameEnum,outputfilename));
+	this->parameters->SetParam(output_fid,OutputFilePointerEnum);
+
+	/*Save lock file name for later: */
+	this->parameters->AddObject(new StringParam(LockFileNameEnum,lockfilename));
+
+	}
+/*}}}*/
+void FemModel::CleanUp(void){/*{{{*/
+
+	/*Intermediary*/
+	FILE *output_fid;
+	char *outbinfilename = NULL;
+	char *lockfilename   = NULL;
+	bool  waitonlock     = false;
+
+	/*Close output file: */
+	this->parameters->FindParam(&output_fid,OutputFilePointerEnum);
+	this->parameters->FindParam(&outbinfilename,OutputFileNameEnum);
+	pfclose(output_fid,outbinfilename);
+
+	/*Write lock file if requested: */
+	this->parameters->FindParam(&waitonlock,SettingsWaitonlockEnum);
+	this->parameters->FindParam(&lockfilename,LockFileNameEnum);
+	if(waitonlock){
+		_printf0_("write lock file:\n");
+		WriteLockFile(lockfilename);
+	}
+
 	/*Before we delete the profiler, report statistics for this run: */
 	profiler->Tag(Finish);  //final tagging
@@ -144,108 +239,24 @@
 	_printf0_("\n");
 	_printf0_("   Total elapsed time:"
-			<<profiler->DeltaTimeModHour(Start,Finish)<<" hrs "
-			<<profiler->DeltaTimeModMin(Start,Finish)<<" min "
-			<<profiler->DeltaTimeModSec(Start,Finish)<<" sec"
-			);
+				<<profiler->DeltaTimeModHour(Start,Finish)<<" hrs "
+				<<profiler->DeltaTimeModMin(Start,Finish)<<" min "
+				<<profiler->DeltaTimeModSec(Start,Finish)<<" sec"
+				);
 	_printf0_("\n");
-
-	/*Now delete: */
-	delete profiler;
 
 	/*Finalize PETSC for this model: */
 	#ifdef _HAVE_PETSC_
 	_printf0_("closing PETSc\n");
-	PetscFinalize(); 
+	PetscFinalize();
 	#endif
 
-}
-/*}}}*/
-
-/*Object management*/
-/*FUNCTION FemModel::Echo {{{*/
-void FemModel::Echo(void){
-
-	_printf_("FemModel echo: \n");
-	_printf_("   number of fem models: " << nummodels << "\n");
-	_printf_("   analysis_type_list: \n");
-	for(int i=0;i<nummodels;i++)_printf_("     " << i << ": " << EnumToStringx(analysis_type_list[i]) << "\n");
-	_printf_("   current analysis_type: \n");
-	_printf_("     " << analysis_counter << ": " << EnumToStringx(analysis_type_list[analysis_counter]) << "\n");
-
-}
-/*}}}*/
-/*FUNCTION FemModel::InitFromFiles(char* rootpath, char* inputfilename, char* outputfilename, char* toolkitsfilename, char* lockfilename, const int in_solution_type,const int* analyses,const int nummodels){{{*/
-void FemModel::InitFromFiles(char* rootpath, char* inputfilename, char* outputfilename, char* toolkitsfilename, char* lockfilename, const int in_solution_type,const int* analyses,const int nummodels){
-
-	/*intermediary*/
-	int         i;
-	int         analysis_type;
-	FILE       *IOMODEL = NULL;
-	FILE       *toolkitsoptionsfid = NULL;
-	FILE       *output_fid = NULL;
-	int         my_rank;
-
-	/*recover my_rank:*/
-	my_rank=IssmComm::GetRank();
-
-	/*Open input file on cpu 0: */
-	if(my_rank==0) IOMODEL = pfopen0(inputfilename ,"rb");
-
-	/*Open toolkits file: */
-	toolkitsoptionsfid=pfopen(toolkitsfilename,"r");
-
-	/*Initialize internal data: */
-	this->nummodels        = nummodels;
-	this->solution_type    = in_solution_type;
-	this->analysis_counter = nummodels-1;   //point to last analysis_type carried out.
-	this->results          = new Results(); //not initialized by CreateDataSets
-
-	/*Dynamically allocate whatever is a list of length nummodels: */
-	analysis_type_list=xNew<int>(nummodels);
-
-	/*Initialize: */
-	for(i=0;i<nummodels;i++)analysis_type_list[i]=analyses[i];
-
-	/*create datasets for all analyses*/
-	ModelProcessorx(&this->elements,&this->nodes,&this->vertices,&this->materials,&this->constraints,&this->loads,&this->parameters,IOMODEL,toolkitsoptionsfid,rootpath,this->solution_type,nummodels,analyses);
-
-	/*do the post-processing of the datasets to get an FemModel that can actually run analyses: */
-	for(i=0;i<nummodels;i++){
-
-		if(VerboseMProcessor()) _printf0_("   Processing finite element model of analysis " << EnumToStringx(analysis_type_list[i]) << ":\n");
-		analysis_type=analysis_type_list[i];
-		this->SetCurrentConfiguration(analysis_type);
-
-		if(i==0){
-			if(VerboseMProcessor()) _printf0_("      creating vertex PIDs\n");
-			VerticesDofx(vertices,parameters); //only call once, we only have one set of vertices
-		}
-
-		if(VerboseMProcessor()) _printf0_("      resolving node constraints\n");
-		SpcNodesx(nodes,constraints,parameters,analysis_type); 
-
-		if(VerboseMProcessor()) _printf0_("      creating nodal degrees of freedom\n");
-		NodesDofx(nodes,parameters,analysis_type);
-
-		if(VerboseMProcessor()) _printf0_("      configuring element and loads\n");
-		ConfigureObjectsx(elements, loads, nodes, vertices, materials,parameters);
-	}
-
-	/*Close input file and toolkits file descriptors: */
-	if(my_rank==0) pfclose(IOMODEL,inputfilename);
-	pfclose(toolkitsoptionsfid,toolkitsfilename);
-
-	/*Open output file once for all and add output file name and file descriptor to parameters*/
-	output_fid=pfopen(outputfilename,"wb");
-	this->parameters->AddObject(new StringParam(OutputFileNameEnum,outputfilename));
-	this->parameters->SetParam(output_fid,OutputFilePointerEnum);
-
-	/*Save lock file name for later: */
-	this->parameters->AddObject(new StringParam(LockFileNameEnum,lockfilename));
-
-	}
-/*}}}*/
-/*FUNCTION FemModel::SetStaticComm {{{*/
-void FemModel::SetStaticComm(void){
+
+	/*Clean up*/
+	xDelete<char>(outbinfilename);
+	xDelete<char>(lockfilename);
+
+}
+/*}}}*/
+void FemModel::SetStaticComm(void){/*{{{*/
 
 	/*This routine sets the global communicator variable hidden inside the IssmComm 
@@ -255,6 +266,5 @@
 }
 /*}}}*/
-/*FUNCTION FemModel::SetCurrentConfiguration(int configuration_type,int analysis_type){{{*/
-void FemModel::SetCurrentConfiguration(int configuration_type,int analysis_type){
+void FemModel::SetCurrentConfiguration(int configuration_type,int analysis_type){/*{{{*/
 
 	/*Use configuration_type to setup the analysis counter, the configurations of objects etc ... but use 
@@ -290,11 +300,9 @@
 }
 /*}}}*/
-/*FUNCTION FemModel::SetCurrentConfiguration(int configuration_type){{{*/
-void FemModel::SetCurrentConfiguration(int configuration_type){
+void FemModel::SetCurrentConfiguration(int configuration_type){/*{{{*/
 	this->SetCurrentConfiguration(configuration_type,configuration_type);
 }
 /*}}}*/
-/*FUNCTION FemModel::Solve {{{*/
-void FemModel::Solve(void){
+void FemModel::Solve(void){/*{{{*/
 
 	/*profiling: */
@@ -357,4 +365,52 @@
 }
 /*}}}*/
+FemModel* FemModel::copy(void){/*{{{*/
+
+	FemModel* output=NULL;
+	int       i;
+	int       analysis_type;
+
+	output=new FemModel(*this); //Use default copy constructor.
+
+	output->comm = this->comm;
+	output->nummodels = this->nummodels;
+	output->solution_type = this->solution_type;
+	output->analysis_counter = this->analysis_counter;
+
+	/*Now, deep copy arrays: */
+	output->analysis_type_list=xNew<int>(nummodels);
+	xMemCpy<int>(output->analysis_type_list,this->analysis_type_list,this->nummodels);
+
+	output->profiler=static_cast<Profiler*>(this->profiler->copy());
+
+	output->loads=static_cast<Loads*>(this->loads->Copy());
+	output->materials=static_cast<Materials*>(this->materials->Copy());
+	output->parameters=static_cast<Parameters*>(this->parameters->Copy());
+	output->constraints=static_cast<Constraints*>(this->constraints->Copy());
+	output->results=static_cast<Results*>(this->results->Copy());
+
+	output->nodes=static_cast<Nodes*>(this->nodes->Copy());
+	output->vertices=static_cast<Vertices*>(this->vertices->Copy());
+	output->elements=static_cast<Elements*>(this->elements->Copy());
+
+	/*reset hooks for elements, loads and nodes: */
+	output->elements->ResetHooks();
+	output->loads->ResetHooks();
+	output->materials->ResetHooks();
+
+	/*do the post-processing of the datasets to get an FemModel that can actually run analyses: */
+	for(i=0;i<nummodels;i++){
+		analysis_type=output->analysis_type_list[i];
+		output->SetCurrentConfiguration(analysis_type);
+		if(i==0) VerticesDofx(output->vertices,output->parameters); //only call once, we only have one set of vertices
+		SpcNodesx(output->nodes,output->constraints,output->parameters,analysis_type);
+		NodesDofx(output->nodes,output->parameters,analysis_type);
+		ConfigureObjectsx(output->elements,output->loads,output->nodes,output->vertices,output->materials,output->parameters);
+	}
+
+	return output;
+}
+/*}}}*/
+
 /*Modules:*/
 int  FemModel::UpdateVertexPositionsx(void){ /*{{{*/
@@ -436,15 +492,15 @@
 		case IceVolumeAboveFloatationEnum: this->IceVolumeAboveFloatationx(responses); break;
 		case MinVelEnum:                   this->MinVelx(responses); break;
-		case MaxVelEnum:                   this->MaxVelx(                  responses); break;
+		case MaxVelEnum:                   this->MaxVelx(responses); break;
 		case MinVxEnum:                    this->MinVxx(responses); break;
-		case MaxVxEnum:                    this->MaxVxx(                   responses); break;
-		case MaxAbsVxEnum:                 this->MaxAbsVxx(                responses); break;
+		case MaxVxEnum:                    this->MaxVxx(responses); break;
+		case MaxAbsVxEnum:                 this->MaxAbsVxx(responses); break;
 		case MinVyEnum:                    this->MinVyx(responses); break;
-		case MaxVyEnum:                    this->MaxVyx(                   responses); break;
-		case MaxAbsVyEnum:                 this->MaxAbsVyx(                responses); break;
+		case MaxVyEnum:                    this->MaxVyx(responses); break;
+		case MaxAbsVyEnum:                 this->MaxAbsVyx(responses); break;
 		case MinVzEnum:                    this->MinVzx(responses); break;
-		case MaxVzEnum:                    this->MaxVzx(                   responses); break;
-		case MaxAbsVzEnum:                 this->MaxAbsVzx(                responses); break;
-		case MassFluxEnum:                 this->MassFluxx(         responses); break;
+		case MaxVzEnum:                    this->MaxVzx(responses); break;
+		case MaxAbsVzEnum:                 this->MaxAbsVzx(responses); break;
+		case MassFluxEnum:                 this->MassFluxx(responses); break;
 		case SurfaceAbsVelMisfitEnum:      SurfaceAbsVelMisfitx(responses, elements,nodes, vertices, loads, materials,parameters); break;
 		case SurfaceRelVelMisfitEnum:      SurfaceRelVelMisfitx(responses, elements,nodes, vertices, loads, materials,parameters); break;
@@ -459,4 +515,5 @@
 		case DragCoefficientAbsGradientEnum:DragCoefficientAbsGradientx(responses, elements,nodes, vertices, loads, materials, parameters); break;
 		case BalancethicknessMisfitEnum:   BalancethicknessMisfitx(responses); break;
+		case Balancethickness2MisfitEnum:  Balancethickness2Misfitx(responses); break;
 		case TotalSmbEnum:					  this->TotalSmbx(responses); break;
 		case MaterialsRheologyBbarEnum:    this->ElementResponsex(responses,MaterialsRheologyBbarEnum); break;
@@ -535,4 +592,5 @@
 				case DragCoefficientAbsGradientEnum:DragCoefficientAbsGradientx(&double_result,elements,nodes,vertices,loads,materials,parameters); break;
 				case BalancethicknessMisfitEnum:    BalancethicknessMisfitx(&double_result);                                                        break;
+				case Balancethickness2MisfitEnum:  Balancethickness2Misfitx(&double_result); break;
 
 			   /*Vector */
@@ -541,10 +599,17 @@
 					/*Vector layout*/
 					int interpolation,nodesperelement,size;
+					int rank_interpolation=-1,rank_nodesperelement=-1;
 
 					/*Get interpolation (and compute input if necessary)*/
 					for(int j=0;j<elements->Size();j++){
 						Element* element=dynamic_cast<Element*>(this->elements->GetObjectByOffset(j));
-						element->ResultInterpolation(&interpolation,&nodesperelement,output_enum);
+						element->ResultInterpolation(&rank_interpolation,&rank_nodesperelement,output_enum);
 					}
+
+					/*Broadcast for cpus that do not have any elements*/
+					ISSM_MPI_Reduce(&rank_interpolation,&interpolation,1,ISSM_MPI_INT,ISSM_MPI_MAX,0,IssmComm::GetComm());
+					ISSM_MPI_Reduce(&rank_nodesperelement,&nodesperelement,1,ISSM_MPI_INT,ISSM_MPI_MAX,0,IssmComm::GetComm());
+					ISSM_MPI_Bcast(&interpolation,1,ISSM_MPI_INT,0,IssmComm::GetComm());
+					ISSM_MPI_Bcast(&nodesperelement,1,ISSM_MPI_INT,0,IssmComm::GetComm());
 
 					if(results_on_nodes){
@@ -774,6 +839,6 @@
 	maxabsvx=-INFINITY;
 	for(i=0;i<this->elements->Size();i++){
-		Element* element=(Element*)this->elements->GetObjectByOffset(i);
-		element->MaxAbsVx(&element_maxabsvx);
+		Element* element=dynamic_cast<Element*>(this->elements->GetObjectByOffset(i));
+		element_maxabsvx=element->inputs->MaxAbs(VxEnum);
 		if(element_maxabsvx>maxabsvx) maxabsvx=element_maxabsvx;
 	}
@@ -798,6 +863,6 @@
 	maxabsvy=-INFINITY;
 	for(i=0;i<this->elements->Size();i++){
-		Element* element=(Element*)this->elements->GetObjectByOffset(i);
-		element->MaxAbsVy(&element_maxabsvy);
+		Element* element=dynamic_cast<Element*>(this->elements->GetObjectByOffset(i));
+		element_maxabsvy=element->inputs->MaxAbs(VyEnum);
 		if(element_maxabsvy>maxabsvy) maxabsvy=element_maxabsvy;
 	}
@@ -822,6 +887,6 @@
 	maxabsvz=-INFINITY;
 	for(i=0;i<this->elements->Size();i++){
-		Element* element=(Element*)this->elements->GetObjectByOffset(i);
-		element->MaxAbsVz(&element_maxabsvz);
+		Element* element=dynamic_cast<Element*>(this->elements->GetObjectByOffset(i));
+		element_maxabsvz=element->inputs->MaxAbs(VzEnum);
 		if(element_maxabsvz>maxabsvz) maxabsvz=element_maxabsvz;
 	}
@@ -846,6 +911,6 @@
 	maxvel=-INFINITY;
 	for(i=0;i<this->elements->Size();i++){
-		Element* element=(Element*)this->elements->GetObjectByOffset(i);
-		element->MaxVel(&element_maxvel);
+		Element* element=dynamic_cast<Element*>(this->elements->GetObjectByOffset(i));
+		element_maxvel = element->inputs->Max(VelEnum);
 		if(element_maxvel>maxvel) maxvel=element_maxvel;
 	}
@@ -870,6 +935,6 @@
 	maxvx=-INFINITY;
 	for(i=0;i<this->elements->Size();i++){
-		Element* element=(Element*)this->elements->GetObjectByOffset(i);
-		element->MaxVx(&element_maxvx);
+		Element* element=dynamic_cast<Element*>(this->elements->GetObjectByOffset(i));
+		element_maxvx = element->inputs->Max(VxEnum);
 		if(element_maxvx>maxvx) maxvx=element_maxvx;
 	}
@@ -894,6 +959,6 @@
 	maxvy=-INFINITY;
 	for(i=0;i<this->elements->Size();i++){
-		Element* element=(Element*)this->elements->GetObjectByOffset(i);
-		element->MaxVy(&element_maxvy);
+		Element* element=dynamic_cast<Element*>(this->elements->GetObjectByOffset(i));
+		element_maxvy = element->inputs->Max(VyEnum);
 		if(element_maxvy>maxvy) maxvy=element_maxvy;
 	}
@@ -918,6 +983,6 @@
 	maxvz=-INFINITY;
 	for(i=0;i<this->elements->Size();i++){
-		Element* element=(Element*)this->elements->GetObjectByOffset(i);
-		element->MaxVz(&element_maxvz);
+		Element* element=dynamic_cast<Element*>(this->elements->GetObjectByOffset(i));
+		element_maxvz = element->inputs->Max(VzEnum);
 		if(element_maxvz>maxvz) maxvz=element_maxvz;
 	}
@@ -942,6 +1007,6 @@
 	minvel=INFINITY;
 	for(i=0;i<this->elements->Size();i++){
-		Element* element=(Element*)this->elements->GetObjectByOffset(i);
-		element->MinVel(&element_minvel);
+		Element* element=dynamic_cast<Element*>(this->elements->GetObjectByOffset(i));
+		element_minvel = element->inputs->Min(VelEnum);
 		if(element_minvel<minvel) minvel=element_minvel;
 	}
@@ -966,6 +1031,6 @@
 	minvx=INFINITY;
 	for(i=0;i<this->elements->Size();i++){
-		Element* element=(Element*)this->elements->GetObjectByOffset(i);
-		element->MinVx(&element_minvx);
+		Element* element=dynamic_cast<Element*>(this->elements->GetObjectByOffset(i));
+		element_minvx = element->inputs->Min(VxEnum);
 		if(element_minvx<minvx) minvx=element_minvx;
 	}
@@ -990,6 +1055,6 @@
 	minvy=INFINITY;
 	for(i=0;i<this->elements->Size();i++){
-		Element* element=(Element*)this->elements->GetObjectByOffset(i);
-		element->MinVy(&element_minvy);
+		Element* element=dynamic_cast<Element*>(this->elements->GetObjectByOffset(i));
+		element_minvy = element->inputs->Min(VyEnum);
 		if(element_minvy<minvy) minvy=element_minvy;
 	}
@@ -1014,6 +1079,6 @@
 	minvz=INFINITY;
 	for(i=0;i<this->elements->Size();i++){
-		Element* element=(Element*)this->elements->GetObjectByOffset(i);
-		element->MinVz(&element_minvz);
+		Element* element=dynamic_cast<Element*>(this->elements->GetObjectByOffset(i));
+		element_minvz = element->inputs->Min(VzEnum);
 		if(element_minvz<minvz) minvz=element_minvz;
 	}
@@ -1139,5 +1204,5 @@
 
 	IssmDouble  weight,vx,vy,H,dvx[2],dvy[2],dH[2];
-	IssmDouble  temp,Jdet,dhdt,basal_melting,surface_mass_balance;
+	IssmDouble  temp,Jdet,dhdt,groundedice_melting,surface_mass_balance;
 	IssmDouble* xyz_list = NULL;
 	IssmDouble  dp[3];
@@ -1152,11 +1217,11 @@
 		/* Get node coordinates*/
 		element->GetVerticesCoordinates(&xyz_list);
-		Input* weights_input              = element->GetInput(InversionCostFunctionsCoefficientsEnum);   _assert_(weights_input);
-		Input* thickness_input            = element->GetInput(ThicknessEnum); _assert_(thickness_input);
-		Input* vx_input                   = element->GetInput(VxEnum);                                 _assert_(vx_input);
-		Input* vy_input                   = element->GetInput(VyEnum);                                 _assert_(vy_input);
-		Input* surface_mass_balance_input = element->GetInput(SurfaceforcingsMassBalanceEnum);         _assert_(surface_mass_balance_input);
-		Input* basal_melting_input        = element->GetInput(BasalforcingsMeltingRateEnum);           _assert_(basal_melting_input);
-		Input* dhdt_input                 = element->GetInput(BalancethicknessThickeningRateEnum);     _assert_(dhdt_input);
+		Input* weights_input                   = element->GetInput(InversionCostFunctionsCoefficientsEnum);   _assert_(weights_input);
+		Input* thickness_input                 = element->GetInput(ThicknessEnum); _assert_(thickness_input);
+		Input* vx_input                        = element->GetInput(VxEnum);                                  _assert_(vx_input);
+		Input* vy_input                        = element->GetInput(VyEnum);                                  _assert_(vy_input);
+		Input* surface_mass_balance_input      = element->GetInput(SurfaceforcingsMassBalanceEnum);          _assert_(surface_mass_balance_input);
+		Input* groundedice_melting_input       = element->GetInput(BasalforcingsGroundediceMeltingRateEnum); _assert_(groundedice_melting_input);
+		Input* dhdt_input                      = element->GetInput(BalancethicknessThickeningRateEnum);      _assert_(dhdt_input);
 
 		/* Start  looping on the number of gaussian points: */
@@ -1174,5 +1239,5 @@
 			thickness_input->GetInputDerivativeValue(&dH[0],xyz_list,gauss);
 			surface_mass_balance_input->GetInputValue(&surface_mass_balance,gauss);
-			basal_melting_input->GetInputValue(&basal_melting,gauss);
+			groundedice_melting_input->GetInputValue(&groundedice_melting,gauss);
 			dhdt_input->GetInputValue(&dhdt,gauss);
 			vx_input->GetInputValue(&vx,gauss);
@@ -1182,5 +1247,5 @@
 
 			/*Balance thickness soft constraint J = 1/2 (div(Hv)-a)^2*/
-			temp  = vx*dH[0]+vy*dH[1]+H*(dvx[0]+dvy[1]) - (surface_mass_balance-basal_melting-dhdt);
+			temp  = vx*dH[0]+vy*dH[1]+H*(dvx[0]+dvy[1]) - (surface_mass_balance-groundedice_melting-dhdt);
 			J    +=weight*1/2*temp*temp*Jdet*gauss->weight;
 		}
@@ -1200,4 +1265,81 @@
 
 }/*}}}*/
+void FemModel::Balancethickness2Misfitx(IssmDouble* presponse){/*{{{*/
+
+	/*output: */
+	IssmDouble J=0.;
+	IssmDouble J_sum;
+
+	IssmDouble  weight,thicknessobs,thickness,potential;
+	IssmDouble  vx,vy,vxbar,vybar,vxobs,vyobs,vxbarobs,vybarobs,nux,nuy;
+	IssmDouble  Jdet;
+	IssmDouble* xyz_list = NULL;
+
+	/*Compute Misfit: */
+	for(int i=0;i<elements->Size();i++){
+		Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
+
+		/*If on water, return 0: */
+		if(!element->IsIceInElement()) continue;
+
+		/* Get node coordinates*/
+		element->GetVerticesCoordinates(&xyz_list);
+		Input* weights_input     =element->GetInput(InversionCostFunctionsCoefficientsEnum); _assert_(weights_input);
+		Input* thickness_input   =element->GetInput(ThicknessEnum);                          _assert_(thickness_input);
+		Input* thicknessobs_input=element->GetInput(InversionThicknessObsEnum);              _assert_(thicknessobs_input);
+		Input* potential_input   =element->GetInput(PotentialEnum);                          _assert_(potential_input);
+		Input* vxobs_input       =element->GetInput(BalancethicknessVxObsEnum); _assert_(vxobs_input);
+		Input* vyobs_input       =element->GetInput(BalancethicknessVyObsEnum); _assert_(vyobs_input);
+		Input* vx_input          =element->GetInput(VxEnum); _assert_(vx_input);
+		Input* vy_input          =element->GetInput(VyEnum); _assert_(vy_input);
+		Input* nux_input       = element->GetInput(BalancethicknessNuxEnum);   _assert_(nux_input);
+		Input* nuy_input       = element->GetInput(BalancethicknessNuyEnum);   _assert_(nuy_input);
+
+		/* Start  looping on the number of gaussian points: */
+		Gauss* gauss=element->NewGauss(2);
+		for(int ig=gauss->begin();ig<gauss->end();ig++){
+
+			gauss->GaussPoint(ig);
+
+			/* Get Jacobian determinant: */
+			element->JacobianDeterminant(&Jdet,xyz_list,gauss);
+
+			/*Get all parameters at gaussian point*/
+			weights_input->GetInputValue(&weight,gauss,Balancethickness2MisfitEnum);
+			thickness_input->GetInputValue(&thickness,gauss);
+			thicknessobs_input->GetInputValue(&thicknessobs,gauss);
+			potential_input->GetInputValue(&potential,gauss);
+			vxobs_input->GetInputValue(&vxobs,gauss);
+			vyobs_input->GetInputValue(&vyobs,gauss);
+			vx_input->GetInputValue(&vxbar,gauss);
+			vy_input->GetInputValue(&vybar,gauss);
+			nux_input->GetInputValue(&nux,gauss);
+			nuy_input->GetInputValue(&nuy,gauss);
+
+			vxbarobs = nux*vxobs;
+			vybarobs = nuy*vyobs;
+
+			/*J = (H^2 - Hobs^2)^2*/
+			//J +=0.5*(thickness*thickness - thicknessobs*thicknessobs)*(thickness*thickness - thicknessobs*thicknessobs)*weight*Jdet*gauss->weight;
+			/*J = phi^2*/
+			//J +=.5*potential*potential*weight*Jdet*gauss->weight; OK
+			/*J = (ubar - nux*uobs)^2*/
+			J +=0.5*((vxbarobs - vxbar)*(vxbarobs - vxbar) + (vybarobs - vybar)*(vybarobs - vybar))*weight*Jdet*gauss->weight;
+		}
+
+		/*clean up and Return: */
+		xDelete<IssmDouble>(xyz_list);
+		delete gauss;
+	}
+
+	/*Sum all J from all cpus of the cluster:*/
+	ISSM_MPI_Reduce (&J,&J_sum,1,ISSM_MPI_DOUBLE,ISSM_MPI_SUM,0,IssmComm::GetComm() );
+	ISSM_MPI_Bcast(&J_sum,1,ISSM_MPI_DOUBLE,0,IssmComm::GetComm());
+	J=J_sum;
+
+	/*Assign output pointers: */
+	*presponse=J;
+
+}/*}}}*/
 void FemModel::ThicknessAbsGradientx( IssmDouble* pJ){/*{{{*/
 
@@ -1235,5 +1377,5 @@
 
 			/*Get all parameters at gaussian point*/
-			weights_input->GetInputValue(&weight,gauss,ThicknessAcrossGradientEnum);
+			weights_input->GetInputValue(&weight,gauss,ThicknessAbsMisfitEnum);
 			thickness_input->GetInputDerivativeValue(&dp[0],xyz_list,gauss);
 
Index: issm/trunk/src/c/classes/FemModel.h
===================================================================
--- issm/trunk/src/c/classes/FemModel.h	(revision 18081)
+++ issm/trunk/src/c/classes/FemModel.h	(revision 18301)
@@ -52,5 +52,7 @@
 		/*Methods:*/
 		void Echo();
+		FemModel* copy();
 		void InitFromFiles(char* rootpath, char* inputfilename, char* outputfilename, char* petscfilename, char* lockfilename, const int solution_type,const int* analyses,const int nummodels);
+		void CleanUp(void);
 		void Solve(void);
 		void SetStaticComm();
@@ -77,4 +79,5 @@
 		void ElementResponsex(IssmDouble* presponse,int response_enum);
 		void BalancethicknessMisfitx(IssmDouble* pV);
+		void Balancethickness2Misfitx(IssmDouble* pV);
 		#ifdef  _HAVE_DAKOTA_
 		void DakotaResponsesx(double* d_responses,char** responses_descriptors,int numresponsedescriptors,int d_numresponses);
